Index: cprs/trunk/CPRS-Chart/Orders/fODBBank.pas
===================================================================
--- cprs/trunk/CPRS-Chart/Orders/fODBBank.pas	(revision 829)
+++ cprs/trunk/CPRS-Chart/Orders/fODBBank.pas	(revision 1679)
@@ -908,10 +898,17 @@
     aTypeScreen := '';
     aSpecimen := '';
+    aSpecimenUID := '';
+    aSpecimenReq := '';
     sub1 := '';
+    aGotTNS := false;
     ExtractTypeScreen(aList, uVBECList);
     if aList.Count > 0 then aTypeScreen := aList[0];
     aList.Clear;
-    Extractspecimen(aList, uVBECList);
-    if aList.Count > 0 then aSpecimen := aList[0];
+    ExtractSpecimen(aList, uVBECList);
+    if aList.Count > 0 then
+      begin
+        aSpecimen := piece(aList[0], '^',1);
+        aSpecimenUID := piece(aList[0], '^',2);
+      end;
     with Responses, ALabTest do
       begin
@@ -963,25 +960,25 @@
                     SetControl(chkConsent,         'YN', AnInstance);
                     //DetermineCollectionDefaults(Responses);
-                    SetControl(cboCollType,        'COLLECT', AnInstance);
-                    SetupCollTimes(cboCollType.ItemID);
-                    //SetControl(cboCollTime,        'START', AnInstance);
-                    //LoadUrgency(cboCollType.ItemID, cboUrgency);
                     SetControl(cboUrgency,         'URGENCY', AnInstance);
-                    Urgency := cboUrgency.ItemIEN;
-                    if (Urgency = 0) and (cboUrgency.Items.Count = AnInstance) then
+                    if cboUrgency.ItemIEN = 0 then
                       begin
-                        cboUrgency.ItemIndex := 0;
-                        Urgency := cboUrgency.ItemIEN;
-                        cboUrgencyChange(self);
+                        if StrToIntDef(LRFURG, 0) > 0 then
+                          cboUrgency.SelectByID(LRFURG)
+                        else if (Urgency = 0) and (cboUrgency.Items.Count = 1) then
+                          cboUrgency.ItemIndex := 0;
                       end;
                     SetControl(cboSurgery,         'MISC', AnInstance);
+                    if Length(cboSurgery.Text) > 0 then
+                      begin
+                        for i := 0 to cboSurgery.Items.Count - 1 do
+                          if uppercase(cboSurgery.Text) = uppercase(piece(cboSurgery.Items[i],'^',2)) then
+                            begin
+                              cboSurgery.ItemIndex := i;
+                              Break;
+                            end;
+                        cboSurgeryChange(self);
+                      end;
                     if not(ALabTest = nil) then
                       begin
-                        Urgency := cboUrgency.ItemIEN;
-                        if (Urgency = 0) and (cboUrgency.Items.Count = 1) then
-                          begin
-                            cboUrgency.ItemIndex := 0;
-                            Urgency := cboUrgency.ItemIEN;
-                          end;
                         i := 1 ;
                         AResponse := Responses.FindResponseByName('COMMENT',i);
@@ -992,16 +989,4 @@
                             AResponse := Responses.FindResponseByName('COMMENT',i);
                           end ;
-                      end;
-                    if not(cboCollType.ItemID = 'LC') then
-                      begin
-                        if Length(cboCollTime.Text) > 0 then
-                          begin
-                            calCollTime.FMDateTime := StrToFMDateTime(cboCollTime.Text);
-                            FLastCollTime := cboCollTime.Text;
-                          end
-                        else
-                          begin
-                            FLastCollTime := '';
-                          end;
                       end;
                   end;
@@ -1014,6 +999,4 @@
                     SetControl(cboModifiers,       'MODIFIER', AnInstance);
                     SetControl(tQuantity,          'QTY', AnInstance);
-                    //DetermineCollectionDefaults(Responses);
-                    //Check for and display any associated Lab Results
                     aList.Clear;
                     TestAdded := 0;
@@ -1043,11 +1026,14 @@
                       if TestAdded = 1 then
                         begin
-                          edtResults.Clear;
                           aTests.Clear;
                           GetPatientBloodResults(aTests, Patient.DFN, uTestsForResults);
-                          QuickCopy(ATests,edtResults);
-                          if edtResults.Lines.Count > 0 then TabResults.Caption := 'Lab Results Available'; //TabResults.ImageIndex := 1;
-                          uRaw.Clear;
-                          GetPatientBloodResultsRaw(uRaw, Patient.DFN, uTestsForResults);
+                          if aTests.Count > 0 then
+                            begin
+                              edtResults.Clear;
+                              QuickCopy(ATests,edtResults);
+                              TabResults.Caption := 'Lab Results Available';
+                              uRaw.Clear;
+                              GetPatientBloodResultsRaw(uRaw, Patient.DFN, uTestsForResults);
+                            end;
                         end;
                       CurAdd := 1;
@@ -1058,5 +1044,7 @@
                           Inc(CurAdd);
                         end;
-                    aSpecimen := '^';
+                    aSpecimen := '';
+                    aSpecimenUID := '';
+                    aSpecimenReq := '';
                     aTestYes := '0';
                     aReason := '';
@@ -1064,9 +1052,12 @@
                     aCollTime := '';
                     ExtractSpecimen(aList, uVBECList);
-                    if aList.Count > 0 then aSpecimen := aList[0];
+                    if aList.Count > 0 then
+                      begin
+                        aSpecimen := piece(aList[0], '^', 1);
+                        aSpecimenUID := piece(aList[0], '^', 2);
+                      end;
                     if length(cboModifiers.ItemID) > 0 then aModifier := cboModifiers.Items[cboModifiers.ItemIndex];
                     if length(cboReasons.ItemID) > 0 then aReason := cboReasons.Items[cboReasons.ItemIndex];
                     if length(cboSurgery.ItemID) > 0 then aSurgery := cboSurgery.Items[cboSurgery.ItemIndex];
-                    if length(cboCollTime.ItemID) > 0 then aCollTime := cboCollTime.Items[cboCollTime.ItemIndex];
                     if Length(cboSurgery.ItemID) > 0 then
                       begin
@@ -1076,5 +1067,5 @@
                           begin
                             if (StrToInt(piece(aList[i],'^',1)) = aLabTest.ItemID)
-                             and (piece(aList[i],'^',3) = cboSurgery.Text) then
+                             and (uppercase((piece(aList[i],'^',3))) = uppercase(cboSurgery.Text)) then
                               begin
                                 aMSBOS := StrToInt(piece(aList[i],'^',4));
@@ -1086,15 +1077,46 @@
                                       aMSBOSContinue :=
                                         MessageBox(PChar('The number of units ordered (' + tQuantity.Text +
-                                                   ') for ' + aLabTest.TestName + ' exceeds the maximum number of units ('
-                                                   + IntToStr(aMSBOS) +
-                                                   ') for the ' + cboSurgery.text +
-                                                   ' surgical procedure selected.' + CRLF + CRLF + 'Do you wish to continue?'),
-                                                   PChar('Maximum Number of Units Exceeded'),
-                                                   MB_YESNO);
+                                           ') for ' + aLabTest.TestName + ' Exceeds the maximum number recommended ('
+                                           + IntToStr(aMSBOS) +
+                                           ') for the ' + cboSurgery.text +
+                                           ' surgical procedure.' + CRLF +
+                                           'If you need to order more than the maximum number of units, please enter a justification in the Comment box.'
+                                            + CRLF + CRLF + 'Edit the Blood component Quantity?'),
+                                           PChar('Maximum Number of Units Exceeded'),
+                                           MB_YESNO);
                                       RestoreTopMosts;
                                     end;
-                                    if aMSBOSContinue = 7 then
+                                    if aMSBOSContinue = 6 then
                                       begin
                                         ShowMsg(cboAvailComp.Text + ' has NOT been added to this request.');
+                                        lvSelectionList.Clear;
+                                        uSelectedItems.Clear;
+                                        uTestsForResults.Clear;
+                                        uRaw.Clear;
+                                        uGetTnS := 0;
+                                        lblTNS.Caption := '';
+                                        lblTNS.Visible := false;
+                                        memMessage.Text := '';
+                                        pnlMessage.Visible := false;
+                                        FLastItemID := '';
+                                        InitDialog;
+                                        cboModifiers.ItemIndex := -1;
+                                        cboAvailTest.ItemIndex := -1;
+                                        cboAvailComp.ItemIndex := -1;
+                                        cboSurgery.ItemIndex := -1;
+                                        cboUrgency.ItemIndex := -1;
+                                        cboReasons.ItemIndex := -1;
+                                        cboCollType.ItemIndex := -1;
+                                        cboCollTime.ItemIndex := -1;
+                                        cboQuick.ItemIndex := -1;
+                                        calWantTime.Text := '';
+                                        memDiagComment.Text := '';
+                                        GroupBox1.Visible := true;
+                                        tQuantity.Text := '';
+                                        FLastCollType := '';
+                                        FLastCollTime := '';
+                                        FLastLabCollTime := '';
+                                        txtImmedColl.Text := '';
+                                        calCollTime.text := '';
                                         exit;
                                       end;
@@ -1103,5 +1125,13 @@
                           end;
                       end;
-                    if (uTNSOrders.Count < 1) then //SpecimenNeeded(aList, uVBECList, aLabTest.ItemID) then  //check to see if type and screen is needed
+                    for i := lvSelectionList.Items.Count - 1 downto 0 do
+                      begin
+                        if lvSelectionList.Items[i].SubItems[3] = aTypeScreen then
+                          begin
+                            aGotTNS := true;
+                            break;
+                          end;
+                      end;
+                    if (uTNSOrders.Count < 1) and (aGotTNS = false) and (SpecimenNeeded(aList, uVBECList, aLabTest.ItemID)) then  //check to see if type and screen is needed CQ 17349
                       begin
                         uGetTnS := 1;
@@ -1113,5 +1143,7 @@
                         if (StrToInt(piece(aList[i],'^',1)) = aLabTest.ItemID) then
                           begin
-                            aSpecimen := piece(aList[i],'^',2) + '^' + aSpecimen;
+                            aSpecimenReq := piece(aList[i],'^',2);
+                            if (SpecimenNeeded(aList, uVBECList, aLabTest.ItemID)) then
+                              aSpecimenUID := '';
                             break;
                           end;
@@ -1136,5 +1168,5 @@
                       end;
                     CurAdd := 1;
-                    aStr := aTestYes + '^' + IntToStr(aLabTest.TestID) + '^' + tQuantity.Text + '^' + aModifier + '^' + aSpecimen + '^' + IntToStr(aLabTest.ItemID);  //aSpecimen has 2 pieces additional pieces added for Tests
+                    aStr := aTestYes + '^' + IntToStr(aLabTest.TestID) + '^' + tQuantity.Text + '^' + aModifier + '^' + aSpecimenReq + '^' + aSpecimen + '^' + aSpecimenUID + '^' + IntToStr(aLabTest.ItemID);
                     uSelectedItems.Add(aStr);
                     for i := 0 to uSelectedItems.Count - 1 do
@@ -1160,61 +1192,4 @@
                   aMsg := '';
                   LRORDERMODE := TORDER_MODE_INFO;
-                  {if uGetTnS = 1 then
-                    begin
-                      lblTNS.Caption := 'TYPE + SCREEN must be added to order';
-                      lblTNS.Visible := true;
-                      memMessage.Text := 'TYPE + SCREEN must be added to order';
-                      memMessage.Visible := false;
-                      pnlMessage.Visible := true;
-                      pnlDiagnosticTests.Caption := 'Diagnostic Tests*';
-                    end;  }
-                  {if uGetTnS = 1 then
-                    begin
-                      if responses.QuickOrder < 1 then
-                        begin
-                          for i := 1 to cboAvailTest.Items.Count - 1 do
-                            begin
-                              if piece(cboAvailTest.Items[i],'^',1) = aTypeScreen then
-                                begin
-                                  if piece(aSpecimen,'^',1) = '1' then
-                                    begin
-                                      cboCollTime.Text := calWantTime.Text;
-                                      aCollSave := cboCollTime.Text + '^' + cboCollTime.ItemID + '^' + cboCollType.Text + '^' + cboCollType.ItemID;
-                                      cboCollTime.Text := '';
-                                      cboCollType.Text := '';
-                                      uSpecimen := 1;
-                                    end;
-                                  cboModifiers.Text := '';
-                                  cboAvailTest.SelectByID(aTypeScreen);
-                                  cboTests.SelectByID(aTypeScreen);
-                                  cboTestsClick(self);
-                                  //cboAvailTestSelect(Self);
-                                  uSpecimen := 0;
-                                  cboCollTime.Text := piece(aCollSave,'^',1);
-                                  cboCollType.Text := piece(aCollSave,'^',3);
-                                  aCollSave := '';
-                                  break;
-                                end;
-                            end;
-                          aMsg := 'An order for Type and Screen has been added to this request' + '.';
-                        end
-                        else
-                          begin
-                            lblTNS.Caption := 'TYPE + SCREEN must be added to order';
-                            lblTNS.Visible := true;
-                            memMessage.Text := 'TYPE + SCREEN must be added to order';
-                            memMessage.Visible := false;
-                            pnlMessage.Visible := true;
-                          end;
-                    end;
-                  if (uGetTnS = 1) then
-                    begin
-                      if length(aMsg) > 0 then aMsg := aMsg + crlf + crlf;
-                      ShowMsg(aMsg);
-                    end;  }
-
-                  //cboModifiers.Text := '';
-                  edtResults.Height := 247;
-                  edtInfo.Height := 247;
                   if lvSelectionList.Items.Count > 0 then
                     begin
@@ -1234,5 +1209,5 @@
                         aTestYes := '1';
                         SetControl(cboAvailTest,       'ORDERABLE', AnInstance);
-                        //DetermineCollectionDefaults(Responses);   //cboCollType = COLLECT , calCollTime = START
+                        //DetermineCollectionDefaults(Responses); //cboCollType = COLLECT , calCollTime = START
                         i := 1 ;
                         AResponse := Responses.FindResponseByName('COMMENT',i);
@@ -1260,13 +1235,17 @@
                           end;
                         if Length(calWantTime.Text) > 0 then Responses.Update('DATETIME',1,ValidCollTime(calWantTime.Text),calWantTime.Text);
-                        with cboCollType do if Length(ItemID) > 0 then
-                          begin
-                            Responses.Update('COLLECT', 1, ItemID, ItemID) ;
-                            FLastCollType := ItemID;
-                          end;
                         if Length(cboUrgency.Text) > 0 then Responses.Update('URGENCY',1,cboUrgency.ItemID,cboUrgency.Text)
                           else
                             begin
-                              cboUrgency.ItemIndex := 1;
+                              cboUrgency.ItemIndex := 2;
+                              for i := 0 to cboUrgency.Items.Count - 1 do
+                                begin
+                                  aUrgText := cboUrgency.Items[i];
+                                  if aUrgText = '9^ROUTINE' then    // Find urgency default of ROUTINE
+                                    begin
+                                      cboUrgency.ItemIndex := i;
+                                      break;
+                                    end;
+                                end;
                               Responses.Update('URGENCY',1,cboUrgency.ItemID,cboUrgency.Text);
                               cboUrgencyChange(self);
@@ -1274,45 +1253,4 @@
                         if Length(memDiagComment.Text) > 0 then Responses.Update('COMMENT',1,memDiagComment.Text,memDiagComment.Text);
                         if Length(cboReasons.Text) > 0 then Responses.Update('REASON',1,cboReasons.Text,cboReasons.Text);
-                        LoadCollType(cboCollType);
-                        if (cboCollType.ItemID = 'LC') or (cboCollType.ItemID = 'I') then
-                          if not(ALabTest.LabCanCollect) and OrderForInpatient then
-                            cboCollType.SelectByID('WC')
-                          else if not(ALabTest.LabCanCollect) then
-                            cboCollType.SelectByID('SP');
-                        SetupCollTimes(cboCollType.ItemID);
-                        if cboCollType.ItemID = 'LC' then
-                          begin
-                            with cboCollTime do
-                              if Length(ItemID) > 0 then
-                                begin
-                                  Responses.Update('START', 1, Copy(ItemID, 2, 999), Copy(ItemID, 2, 999));
-                                  FLastLabCollTime := ItemID + U + Text;
-                                end
-                              else if Length(Text) > 0 then
-                                begin
-                                  Responses.Update('START', 1, ValidCollTime(Text), Text) ;
-                                  FLastLabCollTime := ValidCollTime(Text);
-                                end;
-                          end
-                        else
-                          begin
-                            with calCollTime do
-                              if FMDateTime > 0 then
-                                begin
-                                  Responses.Update('START', 1, ValidCollTime(Text), Text);
-                                  FLastColltime := ValidCollTime(Text);
-                                end
-                              else
-                                begin
-                                  Responses.Update('START', 1, '', '') ;
-                                  FLastCollTime := '';
-                                end;
-                          end;
-                        if length(cboCollTime.ItemID) > 0 then aCollTime := cboCollTime.Items[cboCollTime.ItemIndex];
-                        with cboCollType do if Length(ItemID) > 0 then
-                          begin
-                            Responses.Update('COLLECT', 1, ItemID, ItemID) ;
-                            FLastCollType := ItemID;
-                          end;
                         uTestSelected := true;
                         with lvSelectionList do
@@ -1326,5 +1264,5 @@
                           end;
                         CurAdd := 1;
-                        aStr := aTestYes + '^' + IntToStr(aLabTest.TestID) + '^' + tQuantity.Text + '^' + aModifier + '^' + aSpecimen + '^' + aCollTime + '^' + cboCollType.Text + '^' + IntToStr(aLabTest.ItemID);  //aSpecimen has 2 pieces
+                        aStr := aTestYes + '^' + IntToStr(aLabTest.TestID) + '^' + tQuantity.Text + '^' + aModifier + '^' + aSpecimenReq + '^' + aSpecimen + '^' + aSpecimenUID + '^' + IntToStr(aLabTest.ItemID);
                         uSelectedItems.Add(aStr);
                         for i := 0 to uSelectedItems.Count - 1 do
@@ -1339,6 +1277,4 @@
                           end;
                         memOrder.Text := Responses.OrderText;
-                      edtResults.Height := 247;
-                      edtInfo.Height := 247;
                       if lvSelectionList.Items.Count > 0 then
                         begin
@@ -1353,4 +1289,56 @@
               end;
               //Quick Order
+          end;
+        cList.Clear;
+        if (Length(cboSurgery.ItemID) > 0) then
+          begin
+            for j := 0 to uSelectedItems.Count - 1 do
+              begin
+                xLabTest := TLabTest.Create(piece(uSelectedItems[j],'^',2), Responses);
+                if (piece(uSelectedItems[j],'^',1) = '0') and (not(piece(uSelectedItems[j],'^',3)='')) and (StrToInt(piece(uSelectedItems[j],'^',3)) > 0) and (piece(cboSurgery.Items[cboSurgery.ItemIndex],'^',3) = '1') then
+                  begin
+                    cList.Add(xLabTest.TestName + '^' + piece(uSelectedItems[j],'^',3));
+                  end;
+                xLabTest.Free;
+              end;
+          end;
+        if (uChangingMSBOS = false) and (cList.Count > 0) then
+          begin
+            lblNoBloodReq.Visible := true;
+            with Application do
+              begin
+                NormalizeTopMosts;
+                aMSBOSContinue :=
+                  MessageBox(PChar('No blood is required for the surgical procedure: ' + cboSurgery.text +
+                   '.' + CRLF +
+                   'If you still need to order any components, please enter a justification in the Comment box.'
+                    + CRLF + CRLF + 'Do you want me to remove ALL the component orders you''ve just entered? '),
+                   PChar('No Blood Required'),MB_YESNO);
+                RestoreTopMosts;
+              end;
+            if aMSBOSContinue = 6 then
+              begin
+                tQuantity.Text := '';
+                for j := uSelectedItems.Count - 1 downto 0 do
+                  begin
+                    if not(lvSelectionList.Items[j] = nil) and (piece(uSelectedItems[j],'^',1) = '0') then
+                      begin
+                        lvSelectionList.Items[j].Delete;
+                        uSelectedItems.Delete(j);
+                        Responses.Update('ORDERABLE', (j+1) ,'', '');
+                        Responses.Update('MODIFIER', (j+1), '', '');
+                        Responses.Update('QTY', (j+1), '', '');
+                      end;
+                  end;
+                cboAvailComp.Text := '';
+                cboAvailComp.ItemIndex := -1;
+                cboModifiers.Text := '';
+                cboModifiers.ItemIndex := -1;
+                lblNoBloodReq.Visible := false;
+                //if fODBBank. Active then cboAvailTest.SetFocus;
+                lblTNS.Caption := '';
+                lblTNS.Visible := false;
+                DisableComponentControls;
+              end;
           end;
         for i := 0 to lvSelectionList.Items.Count - 1 do
@@ -1372,12 +1360,11 @@
                       begin
                         NormalizeTopMosts;
-                        aTNSDays := TNSDaysBack;
                         aTNS :=
                           MessageBox(PChar(aTNSString + CRLF + CRLF +
-                                     'Do you wish to continue with this request for Type & Screen?'),
-                                     PChar('Type & Screen Entered in Past ' + IntToStr(TNSDaysBack) + ' Days'),
-                                     MB_YESNO);
+                             'Do you wish to cancel this request for Type & Screen?'),
+                             PChar('Type & Screen Entered in Past ' + IntToStr(TNSDaysBack) + ' Days'),
+                             MB_YESNO);
                         RestoreTopMosts;
-                        if aTNS = 7 then
+                        if aTNS = 6 then
                           begin
                             lvSelectionList.ItemIndex := i;
@@ -1398,5 +1385,6 @@
             pnlMessage.Visible := true;
             pnlDiagnosticTests.Caption := 'Diagnostic Tests*';
-          end;
+          end
+          else pnlDiagnosticTests.Caption := 'Diagnostic Tests';
         if ALabTest <> nil then
           begin
@@ -1440,4 +1428,5 @@
   finally                      //**SubTest
     alist.Free;
+    cList.Free;
     aTests.Free;
   end;
@@ -1719,17 +1708,26 @@
 procedure TLabTest.LoadUrgency(CollType: string; AComboBox:TORComboBox);
 var
-  i: integer;
+  i, PreviousSelectionIndex: integer;
+  PreviousSelectionString: String;
 begin
   if UrgencyList.Count < 1 then Exit;
   with AComboBox do
     begin
+     PreviousSelectionIndex := -1;
+     PreviousSelectionString := SelText;
       Clear;
       for i := 0 to UrgencyList.Count - 1 do
+        begin
          if (CollType = 'LC') and (Piece(UrgencyList[i], U, 3) = '') then
            Continue
          else
            Items.Add(UrgencyList[i]);
+         if (PreviousSelectionString <> '') and (PreviousSelectionString = Piece(UrgencyList[i], U, 2)) then
+           PreviousSelectionIndex := i;
+        end;
       if (LRFURG <> '') and (ALabTest.ObtainUrgency) then
         SelectByID(LRFURG)
+      else if PreviousSelectionIndex > -1 then
+        ItemIndex := PreviousSelectionIndex
       else
         SelectByIEN(uDfltUrgency);
@@ -1864,5 +1862,5 @@
   i:integer;
   aborh: boolean;
-  aSpecimen, aSpecimenDate: string;
+  aSpecimen, aSpecimenUID, aSpecimenDate: string;
   aWantDateTime, aExpiredSpecimenDate: TFMDateTime;
 begin
@@ -1870,4 +1868,5 @@
   aborh := false;
   aSpecimen := '';
+  aSpecimenUID := '';
   OutList.Clear;
   ExtractItems(OutList,Alist,'ABORH');
@@ -1886,25 +1885,35 @@
   OutList.Clear;
   ExtractSpecimen(OutList, uVBECList);
-  if OutList.Count > 0 then aSpecimen := OutList[0];
+  if OutList.Count > 0 then
+    begin
+      aSpecimen := Piece(OutList[0], '^',1);
+      aSpecimenUID := Piece(OutList[0], '^',2);
+    end;
   OutList.Clear;
   ExtractItems(OutList,AList,'SPECIMENS');
   aWantDateTime := calWantTime.FMDateTime;
-  aSpecimenDate := piece(aSpecimen,'^',1);
+  aSpecimenDate := aSpecimen;
   aExpiredSpecimenDate := 0;
   if Length(aSpecimenDate) > 0 then aExpiredSpecimenDate := StrToFloat(aSpecimenDate);
-
   for i := 0 to OutList.Count - 1 do
     begin
       if (IntToStr(aLabTest.ItemID) = piece(OutList[i],'^',1)) and (piece(OutList[i],'^',2) = '1') then
-        if aSpecimen = '' then
-          begin
-            result := true;
-            exit;
-          end
-        else if (Length(calWantTime.Text) > 0) and (aExpiredSpecimenDate < aWantDateTime) then
-          begin
-            result := true;
-            exit;
-          end;
+        begin
+          if self.EvtID > 0 then
+            begin
+              result := true;
+              exit;
+            end;
+          if aSpecimen = '' then
+            begin
+              result := true;
+              exit;
+            end
+          else if (Length(calWantTime.Text) > 0) and (aExpiredSpecimenDate < aWantDateTime) then
+            begin
+              result := true;
+              exit;
+            end;
+        end;
     end;
 end;
@@ -1963,9 +1972,7 @@
   TX_TOO_MANY_DAYS  = 'Maximum number of days allowed is ';
   TX_TOO_MANY_TIMES = 'For this frequency, the maximum number of times allowed is:  X';
-  //TX_NO_COMMENT     = 'A comment is required for this test and collection sample.';
   TX_NUMERIC_REQD   = 'A numeric value is required for urine volume';
   TX_DOSEDRAW_REQD  = 'Both DOSE and DRAW times are required for this order';
   TX_TDM_REQD       = 'A value for LEVEL is required for this order';
-  //TX_ANTICOAG_REQD  = 'You must specify an anticoagulant on this order.' ;
   TX_NO_COLLSAMPLE  = 'A collection sample MUST be specified';
   TX_NO_SPECIMEN    = 'A specimen MUST be specified';
@@ -2189,9 +2196,59 @@
   tmpImmTime, tmpTime: TFMDateTime;
   x, tmpORECALLType, tmpORECALLTime: string;
-begin
+  j: integer;
+  havetest: boolean;
+begin
+  havetest := false;
+  for j := uSelectedItems.Count - 1 downto 0 do
+    begin
+      if not(lvSelectionList.Items[j] = nil) and (piece(uSelectedItems[j],'^',1) = '1') and ((length(calCollTime.Text) > 0) or (length(cboCollTime.Text) > 0)) then
+        begin
+          havetest := true;
+          Break;
+        end;
+    end;
+  //if (havetest = True) and (not(FOrderAction in [ORDER_QUICK, ORDER_EDIT])) then havetest := false;
   x := GetLastCollectionTime;
   tmpORECALLType := Piece(x, U, 1);
   tmpORECALLTime := Piece(x, U, 2);
   if CollType = 'SP' then
+    begin
+      cboColltime.Visible    := False;
+      txtImmedColl.Visible   := False;
+      pnlCollTimeButton.Visible   := False;
+      pnlCollTimeButton.TabStop := False;
+      calCollTime.Visible    := True;
+      calCollTime.Enabled    := True;
+      if FLastCollTime <> '' then
+        begin
+          calCollTime.Text := ValidCollTime(FLastColltime);
+          if IsFMDateTime(calCollTime.Text) then
+            begin
+              calCollTime.Text := FormatFMDateTime('mmm dd,yy@hh:nn', StrToFMDateTime(calColltime.Text));
+              calCollTime.FMDateTime := StrToFMDateTime(FLastCollTime);
+            end;
+        end
+      else if tmpORECALLTime <> '' then
+        begin
+          calCollTime.Text := ValidCollTime(tmpORECALLTime);
+          if IsFMDateTime(calCollTime.Text) then
+            begin
+              calCollTime.Text := FormatFMDateTime('mmm dd,yy@hh:nn', StrToFMDateTime(calColltime.Text));
+              calCollTime.FMDateTime := StrToFMDateTime(tmpORECALLTime);
+            end;
+        end
+      else if LRFDATE <> '' then
+        calCollTime.Text     := LRFDATE
+      else if not(FOrderAction in [ORDER_EDIT]) then
+        calCollTime.Text     := 'TODAY'
+      else if (havetest = false) then
+        calCollTime.Text     := 'TODAY';
+     if (havetest = false) and (RemoveCollTimeDefault = True) then
+        begin
+          calCollTime.Text := '';
+          calCollTime.FMDateTime := 0;
+        end;
+    end
+  else if CollType = 'WC' then
     begin
       cboColltime.Visible    := False;
